package RalliJava;

import java.io.PrintStream;
import java.util.Random;

import fi.jyu.mit.ohj2.Mjonot;

/**
 * @author idamk
 * @version 12.2.2025
 * Vois kirjottaa luokan CRC-kortin vastuut
 *
 */
public class Henkilo {
    
    private int     henkilonTunnusNro;
    private String  etunimi            = "";
    private String  sukunimi        = "";
    private int     ika             = 0;
    private int     rallienMaara    = 0;
    private int     voitetutRallit  = 0;
    private String  seura           = "";
    private String  kotipaikkakunta = "";
    
    private static int seuraavaNro = 1;
    
    
    /**
     * Antaa henkilölle identifioivan tunnusnumeron
     * @return uusi tunnusnumero
     * @example
     * <pre name="test">
     * Henkilo henkilo1 = new Henkilo();
     * henkilo1.getHenkilonTunnusNro()===0;
     * henkilo1.rekisteroi();
     * Henkilo henkilo2 = new Henkilo();
     * henkilo2.rekisteroi();
     * int ht1 = henkilo1.getHenkilonTunnusNro();
     * int ht2 = henkilo2.getHenkilonTunnusNro();
     * ht1 === ht2-1;
     * </pre>
     */
    public int rekisteroi() {
        henkilonTunnusNro = seuraavaNro;
        seuraavaNro++;
        return henkilonTunnusNro;
    }
    
    
    /**
     * Vastaa randomisti eri henkilöiden tietoja
     */
    public void vastaahlo() {
        
        Random r = new Random();
        int n = r.nextInt(4);
        int s = r.nextInt(4);
        int sr = r.nextInt(5);
        int kp = r.nextInt(7);
        ika = r.nextInt(66);
        rallienMaara = r.nextInt(100);
        voitetutRallit = (rallienMaara - r.nextInt(rallienMaara));
        
        if(n==0) etunimi = "Kalle";
        if(n==1) etunimi = "Teemu";
        if(n==2) etunimi = "Oskari";
        if(n==3) etunimi = "Mikko";
        
        if(s==0) sukunimi = "Rovanperä";
        if(s==1) sukunimi = "Asunmaa";
        if(s==2) sukunimi = "Sokka";
        if(s==3) sukunimi = "Heikkilä";
        
        if(sr==0) seura = "Jyväskylän ralliveikot";
        if(sr==1) seura = "Jämsän autopojat";
        if(sr==2) seura = "Kuopion nopeet";
        if(sr==3) seura = "Rovaniemen nopeet shamaanit";
        if(sr==4) seura = "Keuruun pikamannet";
        
        if(kp==0) kotipaikkakunta = "Jyväskylä";
        if(kp==1) kotipaikkakunta = "Jämsä";
        if(kp==2) kotipaikkakunta = "Kuopio";
        if(kp==3) kotipaikkakunta = "Seinäjoki";
        if(kp==4) kotipaikkakunta = "Hyvinkää";
        if(kp==5) kotipaikkakunta = "Rovaniemi";
        if(kp==6) kotipaikkakunta = "Keuruu";
        
        Henkilo henkilo = new Henkilo(henkilonTunnusNro, etunimi, sukunimi, ika, kotipaikkakunta, seura, rallienMaara, voitetutRallit);
        henkilo.tulosta(System.out);
    }
    
    /**
     * selkeä tulostus
     */
    public void vastaaKalle() {
        
        etunimi = "Kalle";
        sukunimi = "Rovanperä";
        ika = 25;
        kotipaikkakunta = "Jyväskylä";
        seura = "Toyota Gazoo Racing WRT";
        rallienMaara = 24;
        voitetutRallit = 24;
        
        Henkilo henkilo = new Henkilo(henkilonTunnusNro, etunimi, sukunimi, ika, kotipaikkakunta, seura, rallienMaara, voitetutRallit);
        henkilo.tulosta(System.out);
    }
    
    
    /**
     * @return tunnusnro
     */
    public  int getHenkilonTunnusNro() {
        return henkilonTunnusNro;
    }
    
    
    /**
     * @param numero numero
     */
    public void setHenkilonTunnusNro(int numero) {
        henkilonTunnusNro = numero;
        // jos tunnusnumero on varattu, seuraavaa numeroa kasvatetaan yhtä suuremmaksi kuin hlon tunnusnro
        if (henkilonTunnusNro >= seuraavaNro) seuraavaNro = henkilonTunnusNro + 1;
    }
    
    /**
     * Alustaa henkilön
     */
    public Henkilo() {
        //ei välttämättä tarttis
    }
    
    /**
     * @param tunnusNro id
     * @param etunimi nimi
     * @param sukunimi sukunimi
     * @param ika ikä
     * @param kotipaikkakunta mistä kotoisin
     * @param seura seura
     * @param rallienMaara rallien määrä
     * @param voitetutRallit voitetut rallit
     */
    public Henkilo(int tunnusNro, String etunimi, String sukunimi, int ika, String kotipaikkakunta, String seura, int rallienMaara, int voitetutRallit) {
    this.etunimi = etunimi;
    this.henkilonTunnusNro = tunnusNro;
    this.sukunimi = sukunimi;
    this.ika = ika;
    this.seura = seura;
    this.kotipaikkakunta = kotipaikkakunta;
    this.rallienMaara = rallienMaara;
    this.voitetutRallit = voitetutRallit;
    }
    
    /**
     * @param tulostettava tietovirta mitä tulostetaan
     */
    public void tulosta(PrintStream tulostettava) {
        tulostettava.println(String.format("%03d", henkilonTunnusNro, 3) + " " + etunimi +  " " + sukunimi + ", ikä: " + ika);
        tulostettava.println("Kotipaikkakunta: " + kotipaikkakunta);
        tulostettava.println("Seura: " + seura);
        tulostettava.println("Osallistunut " + rallienMaara + " ralliin");
        tulostettava.println("Voittanut niistä " + voitetutRallit + ".");
        System.out.println("");
    }
    
    
    /**
     * @return henkilön nimi
     * @example
     * <pre name="test">
     *  Henkilo henkilo = new Henkilo();
     *  henkilo.vastaaKalle();
     *  henkilo.getNimi() =R= "Kalle Rovanperä";
     */
    public String getNimi() {
        return this.etunimi + " " + this.sukunimi;
    }
    
    
    /*
     * Palauttaa tiedot tiedostoon tallennettavana merkkijonona
     * @return henkilon tiedot merkkijonona
     * @example 
     * <pre name="test">
     * Henkilo henkilo = new Henkilo();
     * henkilo.parse("2|Rovanperä|Kalle|");
     * henkilo.toString().startsWith("2|Rovanperä|Kalle|") === true;
     * </pre>
     */
    @Override
    public String toString() {
        return "" + 
                getHenkilonTunnusNro()  + "|" +
                sukunimi                + "|" +
                etunimi                 + "|" +
                ika                     + "|" +
                kotipaikkakunta         + "|" +
                seura                   + "|" +
                rallienMaara            + "|" +
                voitetutRallit          + "|";
    }
    
    
    /**
     * Pilkkoo henkilötiedot osiin merkkijonosta
     * Mukana myös setHenkilonTunnusNro() mikä pitää huolen henkilön tunnusnumerosta
     * @param rivi rivi joka pilkotaan osiin
     * @example
     * <pre name="test">
     * Henkilo henkilo = new Henkilo();
     * henkilo.parse("2|Rovanperä|Kalle|");
     * henkilo.getHenkilonTunnusNro()===2;
     * henkilo.toString().startsWith("2|Rovanperä|Kalle|")===true;
     * henkilo.rekisteroi();
     * int ht = henkilo.getHenkilonTunnusNro();
     * henkilo.parse(""+(ht+20));
     * henkilo.rekisteroi();
     * henkilo.getHenkilonTunnusNro() === ht+20+1;
     * </pre>
     */
    public void parse(String rivi) {
        StringBuffer sb = new StringBuffer(rivi);
        setHenkilonTunnusNro(Mjonot.erota(sb, '|', getHenkilonTunnusNro())); // seuraavan numeron käsittely
        sukunimi = Mjonot.erota(sb, '|', sukunimi);
        etunimi = Mjonot.erota(sb, '|', etunimi);
        ika = Mjonot.erota(sb, '|', ika);
        kotipaikkakunta = Mjonot.erota(sb, '|', kotipaikkakunta);
        seura = Mjonot.erota(sb, '|', seura);
        rallienMaara = Mjonot.erota(sb, '|', rallienMaara);
        voitetutRallit = Mjonot.erota(sb, '|', voitetutRallit);
    }
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Henkilo rovis = new Henkilo();
        Henkilo asunmaa = new Henkilo();
        Henkilo elfyn = new Henkilo();
        rovis.rekisteroi();
        rovis.vastaahlo();
        rovis.tulosta(System.out);
        asunmaa.rekisteroi();
        asunmaa.vastaahlo();
        asunmaa.tulosta(System.out);
        elfyn.rekisteroi();
        elfyn.vastaahlo();
        elfyn.tulosta(System.out);
        
        
    }
}
